package reichert._02_bildbearbeitung;

import processing.core.PApplet;
import processing.core.PImage;

/**
 * Dieses Programm zeigt, wie ein Bild Pixel fr Pixel bearbeitet werden kann.
 * Da die Koordinaten der Pixel keine Rolle spielen, gengt eine einfache
 * Schleife ber alle Pixel.
 */
public class BildbearbeitungRotEntfernen extends PApplet {

	private static final long serialVersionUID = 1L;

	PImage original;
	PImage bearbeitet;

	public void setup() {
		original = loadImage("goldengate.jpg");
		original.loadPixels(); // initialisiere original.pixels
		// original.pixels enthlt jetzt alle Bildpunkte des in
		// der Variable original gespeicherten Bildes

		size(original.width * 2, original.height);

		// erstelle neues, leeres Bild
		bearbeitet = new PImage(original.width, original.height);
		bearbeitet.loadPixels(); // initialisiere bearbeitet.pixels
		// bearbeitet.pixels enthlt original.width * original.height
		// schwarze Pixel

		for (int i = 0; i < original.pixels.length; i++) {
			// Grn- und Blauanteil des i-ten Pixels ermitteln
			float gruen = green(original.pixels[i]);
			float blau = blue(original.pixels[i]);

			// neue Farbe berechnen mit Rotanteil=0,
			// Grn- und Blauanteil wie im Originalbild
			bearbeitet.pixels[i] = color(0, gruen, blau);
		}
		bearbeitet.updatePixels(); // aktualisiere bearbeitet.pixels
	}

	public void draw() {
		// Originalbild anzeigen
		image(original, 0, 0, original.width, original.height);

		// rechts davon bearbeitetes Bild anzeigen
		image(bearbeitet, original.width, 0, bearbeitet.width, bearbeitet.height);
	}

}
